<template>
  <card class="card" :title="title">
    <div>
      <FormulateForm v-model="formProducto" @submit="guardarProducto" name="form">
        <div class="row">
          <div class="col-md-6">
            <FormulateInput
              type="text"
              name="nombre"
              label="Nombre"
              placeholder="Nombre"
              validation="required"
              :validation-messages="{
                required: 'El nombre es requerido'
              }"
            />
          </div>
          <div class="col-md-6">
            <FormulateInput
              type="number"
              name="precio"
              label="Precio"
              placeholder="Precio"
              validation="required|min:1"
              :validation-messages="{
                required: 'El precio es requerido',
                min: 'El precio debe ser mayor que 0 (cero)'
              }"
            />
          </div>
          <div class="col-12">
            <FormulateInput
              class="col-12"
              label="Imagen"
              name="file"
              type="image"
              @change="previewImage"
              accept="image/*"
              :validation="this.accion === 'Add' ? 'required': null"
              :validation-messages="{
                required: 'La imagen es requerida'
              }"
            />
          </div>
        </div>
        <div class="clearfix"></div>
        <div class="row">
          <span
            class="btn btn-danger m-4 col"
            v-if="this.accion==='Edit'"
            @click="this.resetForm"
          >Calcelar</span>
          <button :disabled="loading" class="btn btn-primary m-4 col" v-text="btnSumit"></button>
        </div>
      </FormulateForm>
    </div>
  </card>
</template>
<script>
import { db, storage } from "@/conexion";
import uuid from "uuid";
import swal from "sweetalert";

export default {
  props: {
    producto: {
      type: Object,
      required: false
    },
    accion: String,
    id: String
  },
  watch: {
    producto(newVal, oldVal) {
      this.formProducto = newVal;
    },
    accion(newVal, oldVal) {
      this.title = newVal == "Add" ? "Nuevo Producto" : "Editar Producto";
      this.btnSumit = newVal == "Add" ? "Guardar" : "Editar";
    },
    id(newVal, oldVal) {
      this.idKey = newVal;
    }
  },
  data() {
    return {
      formProducto: this.producto,
      title: this.accion == "Add" ? "Nuevo Producto" : "Editar Producto",
      btnSumit: this.accion == "Add" ? "Guardar" : "Editar",
      idKey: this.id,
      img: {
        data: null,
        uploadValue: 0
      },
      loading: false
    };
  },
  methods: {
    previewImage(event) {
      this.img.uploadValue = 0;
      this.img.data = event.target.files[0];
    },
    //Guardar y Editar producto
    guardarProducto() {
      this.loading = true;
      if (this.accion === "Add") {
        const ref = `productos/${uuid()}-${this.img.data.name}`;
        const storageRef = storage.ref(ref).put(this.img.data);
        storageRef.on(
          `state_changed`,
          snapshot => {
            this.img.uploadValue =
              (snapshot.bytesTransferred / snapshot.totalBytes) * 100;
          },
          error => {
            console.log(error.message);
            this.loading = false;
          },
          () => {
            this.img.uploadValue = 100;
            storageRef.snapshot.ref.getDownloadURL().then(url => {
              delete this.formProducto["file"];
              this.formProducto.img_ref = ref;
              this.formProducto.img_url = url;
              this.formProducto.existencia = 0;
              db.ref("/productos")
                .push(this.formProducto)
                .then(res => {
                  swal("Producto agregado", "", "success");
                  this.resetForm();
                  this.loading = false;
                });
            });
          }
        );
      } else {
        //Editar
        this.loading = true;
        this.formProducto.existencia = 0;
        if (this.img) {
          const storageRef = storage
            .ref(this.formProducto.img_ref)
            .put(this.img.data);
          storageRef.on(
            `state_changed`,
            snapshot => {
              this.img.uploadValue =
                (snapshot.bytesTransferred / snapshot.totalBytes) * 100;
            },
            error => {
              console.log(error.message);
              this.loading = false;
            },
            () => {
              this.img.uploadValue = 100;
              storageRef.snapshot.ref.getDownloadURL().then(url => {
                delete this.formProducto["file"];
                this.formProducto.img_url = url;
                
                db.ref("/productos/" + this.idKey)
                  .update(this.formProducto)
                  .then(res => {
                    swal("Producto editado", "", "success");
                    this.loading = false;
                  });
              });
            }
          );
        } else {
          db.ref("/productos/" + this.idKey)
            .update(this.formProducto)
            .then(res => {
              swal("Producto editado", "", "success");
              this.loading = false;
            });
        }
      }
    },
    resetForm() {
      this.$formulate.reset("form");
      this.accion = "Add";
      // this.$formulate.resetValidation('form');
    }
  }
};
</script>
<style>
</style>
